import { ScoreObject } from '../types';
import { BallotMethod } from './ballot-method';
import { Ranker } from './method';
export declare type Round = {
    finished?: boolean;
    idx: number;
    candidates: string[];
    roundResult: {
        eliminated: string[];
        qualified: string[];
        scores: ScoreObject;
    };
};
export declare abstract class RoundBallotMethod extends BallotMethod implements Ranker {
    protected rounds: Round[];
    computeRounds(): Round[];
    ranking(): string[][];
    protected abstract round(candidates: string[], idx?: number): {
        qualified: string[];
        eliminated: string[];
        scores: ScoreObject;
    };
    private computeNextRound;
    private lastRoundQualified;
}
