import { Ballot } from '../types';
export declare const isBallotEqual: (a: string[][], b: string[][]) => boolean;
export declare const normalizeRankInput: (rankinput: (string | string[])[]) => string[][];
export declare const groupBallots: <B extends Ballot>(ballots: B[]) => B[];
export declare const toWeightedBallots: (ballots: string[][][]) => Ballot[];
export declare const checkDuplicatedCandidate: (ranking: string[][]) => void;
export declare const removeDuplicatedCandidates: (ranking: string[][]) => string[][];
export declare const removeInvalidCandidates: (ranking: string[][], candidates: string[]) => string[][];
export declare const normalizeRanking: (ranking: string[][], candidates: string[]) => string[][];
export declare const normalizeBallot: <B extends Ballot>(ballot: B, candidates: string[]) => B;
export declare const candidatesFromBallots: (ballots: Ballot[]) => string[];
export declare const normalizeBallots: <B extends Ballot>(ballots: B[], candidates?: string[] | undefined) => B[];
export declare const totalBallotsWeight: (ballots: Ballot[]) => number;
